linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Tom Zanussi <zanussi@kernel.org>
To: rostedt@goodmis.org
Cc: tglx@linutronix.de, mhiramat@kernel.org, namhyung@kernel.org,
	vedang.patel@intel.com, bigeasy@linutronix.de,
	joel@joelfernandes.org, mathieu.desnoyers@efficios.com,
	julia@ni.com, linux-kernel@vger.kernel.org,
	linux-rt-users@vger.kernel.org
Subject: [PATCH v12 15/16] tracing: Add alternative synthetic event trace action test case
Date: Tue, 15 Jan 2019 16:05:59 -0600	[thread overview]
Message-ID: <3f7d5cc63500a8fd9aafc784a039ad55235528d8.1547589128.git.tom.zanussi@linux.intel.com> (raw)
In-Reply-To: <cover.1547589128.git.tom.zanussi@linux.intel.com>
In-Reply-To: <cover.1547589128.git.tom.zanussi@linux.intel.com>

From: Tom Zanussi <tom.zanussi@linux.intel.com>

Add a test case for the alternative trace(<synthetic_event, params)
synthetic event generation syntax.

Signed-off-by: Tom Zanussi <tom.zanussi@linux.intel.com>
---
 .../inter-event/trigger-trace-action-hist.tc       | 42 ++++++++++++++++++++++
 1 file changed, 42 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-trace-action-hist.tc

diff --git a/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-trace-action-hist.tc b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-trace-action-hist.tc
new file mode 100644
index 000000000000..8021d60aafec
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-trace-action-hist.tc
@@ -0,0 +1,42 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: event trigger - test inter-event histogram trigger trace action
+
+fail() { #msg
+    echo $1
+    exit_fail
+}
+
+if [ ! -f set_event ]; then
+    echo "event tracing is not supported"
+    exit_unsupported
+fi
+
+if [ ! -f synthetic_events ]; then
+    echo "synthetic event is not supported"
+    exit_unsupported
+fi
+
+grep -q "trace(<synthetic_event>" README || exit_unsupported # version issue
+
+echo "Test create synthetic event"
+
+echo 'wakeup_latency  u64 lat pid_t pid char comm[16]' > synthetic_events
+if [ ! -d events/synthetic/wakeup_latency ]; then
+    fail "Failed to create wakeup_latency synthetic event"
+fi
+
+echo "Test create histogram for synthetic event using trace action"
+echo "Test histogram variables,simple expression support and trace action"
+
+echo 'hist:keys=pid:ts0=common_timestamp.usecs if comm=="ping"' > events/sched/sched_wakeup/trigger
+echo 'hist:keys=next_pid:wakeup_lat=common_timestamp.usecs-$ts0:onmatch(sched.sched_wakeup).trace(wakeup_latency,$wakeup_lat,next_pid,next_comm) if next_comm=="ping"' > events/sched/sched_switch/trigger
+echo 'hist:keys=comm,pid,lat:wakeup_lat=lat:sort=lat' > events/synthetic/wakeup_latency/trigger
+
+ping $LOCALHOST -c 5
+
+if ! grep -q "ping" events/synthetic/wakeup_latency/hist; then
+    fail "Failed to create trace action inter-event histogram"
+fi
+
+exit 0
-- 
2.14.1


  parent reply	other threads:[~2019-01-15 22:06 UTC|newest]

Thread overview: 21+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-01-15 22:05 [PATCH v12 00/16] tracing: Hist trigger snapshot and onchange additions Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 01/16] tracing: Use str_has_prefix() in synth_event_create() Tom Zanussi
2019-01-16  4:59   ` Joe Perches
2019-01-16 15:50     ` Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 02/16] tracing: Refactor hist trigger action code Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 03/16] tracing: Make hist trigger Documentation better reflect actions/handlers Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 04/16] tracing: Split up onmatch action data Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 05/16] tracing: Generalize hist trigger onmax and save action Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 06/16] tracing: Add conditional snapshot Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 07/16] tracing: Add hist trigger snapshot() action Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 08/16] tracing: Add hist trigger snapshot() action Documentation Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 09/16] tracing: Add hist trigger onchange() handler Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 10/16] tracing: Add hist trigger onchange() handler Documentation Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 11/16] tracing: Add alternative synthetic event trace action syntax Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 12/16] tracing: Add SPDX license GPL-2.0 license identifier to inter-event testcases Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 13/16] tracing: Add hist trigger snapshot() action test case Tom Zanussi
2019-01-15 22:05 ` [PATCH v12 14/16] tracing: Add hist trigger onchange() handler " Tom Zanussi
2019-01-15 22:05 ` Tom Zanussi [this message]
2019-01-15 22:06 ` [PATCH v12 16/16] tracing: Add hist trigger action 'expected fail' " Tom Zanussi
2019-01-16  6:43 ` [PATCH v12 00/16] tracing: Hist trigger snapshot and onchange additions Namhyung Kim
2019-01-16 19:02   ` Tom Zanussi

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=3f7d5cc63500a8fd9aafc784a039ad55235528d8.1547589128.git.tom.zanussi@linux.intel.com \
    --to=zanussi@kernel.org \
    --cc=bigeasy@linutronix.de \
    --cc=joel@joelfernandes.org \
    --cc=julia@ni.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-rt-users@vger.kernel.org \
    --cc=mathieu.desnoyers@efficios.com \
    --cc=mhiramat@kernel.org \
    --cc=namhyung@kernel.org \
    --cc=rostedt@goodmis.org \
    --cc=tglx@linutronix.de \
    --cc=vedang.patel@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).